﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace TechNote44_Backlight_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // 현재 BackLight가 On인지 Off인지 확인하기 위한 Flag
        private bool m_bBackLightPlag;
        // 설정한 반복횟수를 저장할 변수
        private int m_iReptCnt;

        private void Form1_Load(object sender, EventArgs e)
        {
            // 현재 Form을 MainForm으로 설정합니다.
            smartForm1.MainForm = this;

            // 멤버 변수 초기화
            m_bBackLightPlag = false;
        }

        // 1. BackLight On / Off 제어하기
        private void btnStart_Click(object sender, EventArgs e)
        {
            smartTimer1.Interval = Convert.ToInt32(udReptInterval.Value);
            smartTimer1.Start();
        }

        // 2. BackLight On / Off 제어 중도 정지
        private void btnStop_Click(object sender, EventArgs e)
        {
            smartTimer1.Stop();
        }

        // 3. BackLight 자동 Off 기능 관련
        private void btnConfig_Click(object sender, EventArgs e)
        {
            // 제어판의 디스플레이 속성에서 조명 설정 창 출력하기
            smartConfigs1.Display.BacklightControlDialogBox();

            // 설정 변경후 레지스트리에 저장
            SmartX.SmartConfigs.RegistryAllSave();
        }

        private void smartTimer1_Tick(object sender, EventArgs e)
        {
            if (m_iReptCnt < udReptCount.Value)
            {
                if (m_bBackLightPlag == false)
                {
                    // Backlight를 OFF
                    smartConfigs1.Display.BacklightControl(SmartX.CDisplay.OnOff.OFF);
                    m_bBackLightPlag = true;
                }
                else
                {
                    // Backlight를 ON
                    smartConfigs1.Display.BacklightControl(SmartX.CDisplay.OnOff.ON);
                    m_bBackLightPlag = false;
                    m_iReptCnt++;
                }
            }
            else
            {
                smartTimer1.Stop();
            }
        }
    }
}